package com.fhkj.oltinspection.service.impl;

import java.util.Optional;

import javax.transaction.Transactional;

import com.fhkj.oltinspection.entity.FtpConfigEntity;
import com.fhkj.oltinspection.pojo.Result;
import com.fhkj.oltinspection.repository.FtpConfigRepository;
import com.fhkj.oltinspection.service.FtpService;
import com.fhkj.oltinspection.util.FTPUtil;
import com.fhkj.oltinspection.util.PackageExceptionUtil;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
@Transactional
public class FtpServiceImpl implements FtpService {

    @Autowired
    private FtpConfigRepository ftpConfigRepository;

    /**
     * @param Intger(id)
     * @return Result
     * @see 登录ftp
     */
    @Override
    public Result loginFtp(Integer id) {
        Optional<FtpConfigEntity> ftpConfigEntityOptional = ftpConfigRepository.findById(id);
        if (ftpConfigEntityOptional.isPresent()) {
            FTPUtil ftpUtil = new FTPUtil();
            return ftpUtil.loginFtp(ftpConfigEntityOptional.get());
        } else {
            return new Result ("未能查询到frp登录所需的信息", false);
        }
    }

    @Override
    public Result saveFtpConfigEntity(FtpConfigEntity ftpConfigEntity) {
        try {
            FtpConfigEntity fce = ftpConfigRepository.save(ftpConfigEntity);
            if (null == fce.getId() || 0 == fce.getId()) {
                return new Result ("保存失败", false);
            } else {
                return new Result ("保存成功", true);
            }
        } catch (Exception e) {
            return new Result ("保存失败", PackageExceptionUtil.exceptionToString(e), false);
        }
    }

}